#define dir1  2       //Rechts
#define stepper1 3    //Rechts
#define dir2 4        //Links
#define stepper2 5    //Links

int trigPinV = A3;     //Ultraschall (US) vorne: Trig
int echoPinV = 7;     //US vorne: Echo
int trigPinL = A1;    //US Links: Trig
int echoPinL = 8;     //US Links: Echo
int trigPinR = A2;    //US Rechts: Trig
int echoPinR = 6;     //US Rechts: Echo
long cm22 = 9, cm32 = 9;  // globale Variablen für US links und rechts

#include <SPI.h>      //RFID
#include <MFRC522.h>  //RFID
#define SS_PIN 10 //RFID
#define RST_PIN 9 //RFID
MFRC522 rfid(SS_PIN, RST_PIN);  //RFID

//RFID

bool rfidFkt() {
  if (rfid.PICC_IsNewCardPresent()) // neuer Tag ist verfügbar
  {

    if (rfid.PICC_ReadCardSerial()) // NUID wurde gelesen
    {
      MFRC522::PICC_Type piccType = rfid.PICC_GetType(rfid.uid.sak);
      Serial.print("RFID/NFC Tag Type: ");
      Serial.println(rfid.PICC_GetTypeName(piccType));

      Serial.print("UID:");    // Ausgabe NUID im Seriellen Monitor im Hex-Format
      for (int i = 0; i < rfid.uid.size; i++)
      {
        Serial.print(rfid.uid.uidByte[i] < 0x10 ? " 0" : " ");
        Serial.print(rfid.uid.uidByte[i], HEX);
      }
      delay(2000);
      Serial.println();
      rfid.PICC_HaltA(); // halt PICC
      rfid.PCD_StopCrypto1(); // Ende Verschlüsselung auf PCD
    }
    return 1; //Rückgabewert wahr oder falsch
  }
  else {
    return 0;
  }
}

//Fahren:

//Geradeaus
void straight(int schritte) // Stepper bewegen sich beide nach vorne
{
  digitalWrite(dir1, HIGH); // High = Vorwärts
  digitalWrite(dir2, HIGH); // für Motor 1 und 2

  for (int n = 0; n < schritte ; n++)
  {
    digitalWrite(stepper1, HIGH); //  eine Seite der Pole wird angestellt
    digitalWrite(stepper2, HIGH);
    delay(5);                     // Verzögerung zwischen Umpolung
    digitalWrite(stepper1, LOW);  // andere Seite wird angestellt ()
    digitalWrite(stepper2, LOW);
    delay(5);
  }
}

//Rückwärts
void back (int schritte)  //beide Stepper drehen sich nach hinten
{
  digitalWrite(dir1, LOW); // rückwärts
  digitalWrite(dir2, LOW);


  for ( int j = 0; j < schritte; j++) // Bewegungsmechanismus des Schrittmotoren
  {
    digitalWrite(stepper1, LOW);
    digitalWrite(stepper2, LOW);
    delay(1);
    digitalWrite(stepper1, HIGH);
    digitalWrite(stepper2, HIGH);
    delay(1);
  }
}

//Links Drehen
void links(int schritte) //es drehen sich beide Stepper vorwärts / rückwärts
{

  digitalWrite(dir1, HIGH);   // fährt vorwärts
  digitalWrite(dir2, LOW);    // fährt rückwärts

  for (int i = 0; i < schritte; i++ ) // bewegungs loop um Stepperdrehnungen durchzuführen
  {
    digitalWrite(stepper1, HIGH);  // stellt die Pole um (stepper1)
    digitalWrite(stepper2, LOW);   // stellt eine Seite aus(stepper 2)
    delay(1);
    digitalWrite(stepper1, LOW);   // stellt die Pole wieder zurück
    digitalWrite(stepper2, HIGH);
    delay(1);
  }
}

//Rechts Drehen  //es drehen sich beide Stepper sychron rückwärts/vorwärts
void rechts(int schritte)
{
  digitalWrite(dir1, LOW); // Stepper rückwärts für Bewegung
  digitalWrite(dir2, HIGH); //Stepper vorwärts für Bewegung

  for (int i = 0; i < schritte; i++ )
  {
    digitalWrite(stepper1, LOW);
    digitalWrite(stepper2, HIGH);
    delay(1);
    digitalWrite(stepper1, HIGH);
    digitalWrite(stepper2, LOW);
    delay(1);
  }
}

void setup()
{
  Serial.begin (9600);
  pinMode(trigPinV, OUTPUT);  //vorderer US Trig Pin
  pinMode(echoPinV, INPUT);   //vorderer US Eco Pin
  pinMode(trigPinL, OUTPUT);  //linker US Trig Pin
  pinMode(echoPinL, INPUT);   //linker US Echo Pin
  pinMode(trigPinR, OUTPUT);  //rechter US Trig Pin
  pinMode(echoPinR, INPUT);   //rechter US Echo Pin
  pinMode(dir1, OUTPUT);  //Fahren
  pinMode(stepper1, OUTPUT);  //Fahren
  pinMode(dir2, OUTPUT);  //Fahren
  pinMode(stepper2, OUTPUT);  //Fahren
  SPI.begin(); // init SPI bus RFID
  rfid.PCD_Init(); // init MFRC522 RFID
}

void loop()
{
  long duration1, cm1;  // Variablen für Ultraschallsensoren
  long duration2, cm2;
  long duration3, cm3;
  digitalWrite(trigPinL, LOW);   //US links Höhe messen
  delayMicroseconds(5);
  digitalWrite(trigPinL, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPinL, LOW);
  pinMode(echoPinL, INPUT);
  duration2 = pulseIn(echoPinL, HIGH);
  cm2 = (duration2 / 2.0) / 29.1;   // in cm berechnen

  if (cm2 > (cm22 + 3)) {  //wenn Differenz zu letztem Wert zu groß
    back(200);             //wenden und drehen(ca. 120 Grad)
    delay(100);
    rechts(218);
  }
  cm22 = cm2;             //neuen Wert in globaler Variable speichern für nächsten Vergleich
  delay(100);

  digitalWrite(trigPinR, LOW); //US rechts  Höhe messen
  delayMicroseconds(5);
  digitalWrite(trigPinR, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPinR, LOW);
  pinMode(echoPinR, INPUT);
  duration3 = pulseIn(echoPinR, HIGH);
  cm3 = (duration3 / 2) / 29.1;   // in cm berechnen

  if (cm3 > (cm32 + 3)) {   //wenn Differenz zu letztem Wert zu groß
    back(200);              //wenden und drehen(ca. 120 Grad)
    delay(100);
    rechts(218);
  }
  cm32 = cm3;
  delay(100);             //neuen Wert in globaler Variable speichern für nächsten Vergleich

  straight(10);           //wenn keine Kante erkannt, geradeaus fahren

  digitalWrite(trigPinV, LOW);    //Entfernung nach vorne messen
  delayMicroseconds(5);
  digitalWrite(trigPinV, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPinV, LOW);
  pinMode(echoPinV, INPUT);
  duration1 = pulseIn(echoPinV, HIGH);   //Signal lesen
  cm1 = (duration1 / 2) / 29.1;         //cm berechnen


  if (cm1 <= 3)       //wenn Gegenstand 3 cm entfernt von US-Sensor ist, RFID-Leser anschalten
  {
    if ( rfidFkt())
    {
      exit;
    }
  }



}
